"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createRouteMiddleware;
exports.setConfig = setConfig;

var _requestCache = require("./requestCache");

var _HtmlGenerator = _interopRequireDefault(require("./HtmlGenerator"));

var config = null;

function createRouteMiddleware(service) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  config = service.config;
  return function (req, res, next) {
    var path = req.path;
    var route = service.routes.filter(function (r) {
      return r.path === path;
    })[0];

    if (route) {
      (0, _requestCache.setRequest)(path, {
        onChange: opts.rebuildEntry
      });
      var htmlGenerator = new _HtmlGenerator.default(service);
      var content = htmlGenerator.getContent({
        pageConfig: (config.pages || {})[path],
        route: route
      });
      res.setHeader('Content-Type', 'text/html');
      res.send(content);
    } else {
      next();
    }
  };
}

function setConfig(_config) {
  config = _config;
}