"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _umiPlugin = require("umi-plugin");

var _lodash = _interopRequireDefault(require("lodash.escaperegexp"));

var _resolvePlugin = _interopRequireDefault(require("./resolvePlugin"));

var _registerBabel = _interopRequireDefault(require("./registerBabel"));

function _default() {
  var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var _opts$configPlugins = opts.configPlugins,
      configPlugins = _opts$configPlugins === void 0 ? [] : _opts$configPlugins,
      _opts$pluginsFromOpts = opts.pluginsFromOpts,
      pluginsFromOpts = _opts$pluginsFromOpts === void 0 ? [] : _opts$pluginsFromOpts,
      babel = opts.babel,
      cwd = opts.cwd;
  var plugins = [].concat((0, _toConsumableArray2.default)(configPlugins || []), (0, _toConsumableArray2.default)(pluginsFromOpts || [])).map(function (p) {
    try {
      return (0, _resolvePlugin.default)(p, {
        cwd: cwd
      });
    } catch (e) {
      throw new Error("Plugin ".concat(p, " don't exists."));
    }
  });

  if (plugins.length) {
    (0, _registerBabel.default)(babel, {
      only: [new RegExp("(".concat(plugins.map(function (p) {
        return (0, _lodash.default)(p);
      }).join('|'), ")"))]
    });
  }

  return (0, _umiPlugin.resolvePlugins)(plugins);
}