"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _stringify = _interopRequireDefault(require("@babel/runtime/core-js/json/stringify"));

var _keys = _interopRequireDefault(require("@babel/runtime/core-js/object/keys"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _path = require("path");

var _fs = require("fs");

var _getConfig = _interopRequireDefault(require("af-webpack/getConfig"));

var _reactDevUtils = require("af-webpack/react-dev-utils");

var _postcssPluginPx2rem = _interopRequireDefault(require("postcss-plugin-px2rem"));

var _umiPlugin = require("umi-plugin");

var _browsers = _interopRequireDefault(require("./defaultConfigs/browsers"));

var debug = require('debug')('umi-build-dev:getWebpackConfig');

function _default() {
  var service = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
  var cwd = service.cwd,
      plugins = service.plugins,
      config = service.config,
      webpackRCConfig = service.webpackRCConfig,
      babel = service.babel,
      hash = service.hash,
      routes = service.routes,
      libraryName = service.libraryName,
      staticDirectory = service.staticDirectory,
      extraResolveModules = service.extraResolveModules,
      paths = service.paths,
      preact = service.preact;
  var isDev = process.env.NODE_ENV === 'development'; // entry

  var entryScript = (0, _path.join)(cwd, "./".concat(paths.tmpDirPath, "/").concat(libraryName, ".js"));
  var setPublicPathFile = (0, _path.join)(__dirname, '../template/setPublicPath.js');
  var hdFile = (0, _path.join)(__dirname, '../template/hd/index.js');
  var compileOnDemandFile = (0, _path.join)(__dirname, '../template/compileOnDemand.js');
  var initialEntry = config.hd ? [hdFile] : [];
  var entry = isDev ? (0, _defineProperty2.default)({}, libraryName, [].concat(initialEntry, (0, _toConsumableArray2.default)(process.env.HMR === 'none' ? [] : [_reactDevUtils.webpackHotDevClientPath]), [entryScript, compileOnDemandFile])) : (0, _defineProperty2.default)({}, libraryName, [].concat(initialEntry, [setPublicPathFile, entryScript]));
  var pageCount = isDev ? null : (0, _keys.default)(routes).length;
  debug("pageCount: ".concat(pageCount));
  debug("config: ".concat((0, _stringify.default)(config))); // default react, support config with preact
  // 优先级：用户配置 > preact argument > default (React)

  var preactAlias = {
    react: require.resolve('preact-compat'),
    'react-dom': require.resolve('preact-compat'),
    'create-react-class': require.resolve('preact-compat/lib/create-react-class')
  };
  var reactAlias = {
    react: require.resolve('react'),
    'react-dom': require.resolve('react-dom')
  };
  var preactOrReactAlias = preact ? preactAlias : reactAlias;

  if (config.preact === true) {
    preactOrReactAlias = preactAlias;
  }

  if (config.preact === false) {
    preactOrReactAlias = reactAlias;
  } // 关于为啥放 webpack 而不放 babel-plugin-module-resolver 里
  // 详见：https://tinyletter.com/sorrycc/letters/babel


  var libAlias = {
    'antd-mobile': (0, _path.dirname)(require.resolve('antd-mobile/package')),
    antd: (0, _path.dirname)(require.resolve('antd/package')),
    'react-router-dom': (0, _path.dirname)(require.resolve('react-router-dom/package')),
    history: (0, _path.dirname)(require.resolve('umi-history/package'))
  }; // 支持用户指定 antd 和 antd-mobile 的版本
  // TODO: 出错处理，用户可能指定了依赖，但未指定 npm install

  var pkgPath = (0, _path.join)(cwd, 'package.json');

  if ((0, _fs.existsSync)(pkgPath)) {
    var _require = require(pkgPath),
        _require$dependencies = _require.dependencies,
        dependencies = _require$dependencies === void 0 ? {} : _require$dependencies;

    if (dependencies.antd) {
      libAlias['antd'] = (0, _path.dirname)(require.resolve((0, _path.join)(cwd, 'node_modules/antd/package')));
    }

    if (dependencies['antd-mobile']) {
      libAlias['antd-mobile'] = (0, _path.dirname)(require.resolve((0, _path.join)(cwd, 'node_modules/antd-mobile/package')));
    }
  }

  var browserslist = webpackRCConfig.browserslist || _browsers.default;
  var webpackConfig = (0, _getConfig.default)((0, _extends2.default)({
    cwd: cwd
  }, webpackRCConfig, {
    // 不允许配置
    entry: entry,
    outputPath: (0, _path.join)(paths.absOutputPath, staticDirectory),
    hash: !isDev && hash,
    // 扩展
    babel: webpackRCConfig.babel || {
      presets: [[babel, {
        browsers: browserslist
      }]]
    },
    browserslist: browserslist,
    theme: (0, _extends2.default)({}, webpackRCConfig.theme, config.hd ? {
      '@hd': '2px'
    } : {}),
    extraResolveModules: [].concat((0, _toConsumableArray2.default)(webpackRCConfig.extraResolveModules || []), (0, _toConsumableArray2.default)(extraResolveModules || [])),
    cssModulesExcludes: [].concat((0, _toConsumableArray2.default)(webpackRCConfig.cssModulesExcludes || []), [(0, _path.join)(paths.absSrcPath, 'global.css'), (0, _path.join)(paths.absSrcPath, 'global.less')]),
    define: (0, _extends2.default)({
      // 禁用 antd-mobile 升级提醒
      'process.env.DISABLE_ANTD_MOBILE_UPGRADE': true,
      // For registerServiceWorker.js
      'process.env.BASE_URL': process.env.BASE_URL,
      __UMI_HTML_SUFFIX: !!(config.exportStatic && typeof config.exportStatic === 'object' && config.exportStatic.htmlSuffix)
    }, webpackRCConfig.define || {}),
    alias: (0, _extends2.default)({}, preactOrReactAlias, libAlias, webpackRCConfig.alias || {}),
    extraPostCSSPlugins: [].concat((0, _toConsumableArray2.default)(webpackRCConfig.extraPostCSSPlugins || []), (0, _toConsumableArray2.default)(config.hd ? [(0, _postcssPluginPx2rem.default)({
      rootValue: 100,
      minPixelValue: 2
    })] : []))
  }, isDev ? {
    // 生产环境的 publicPath 是服务端把 assets 发布到 cdn 后配到 HTML 里的
    // 开发环境的 publicPath 写死 /static/
    publicPath: "/"
  } : (0, _extends2.default)({
    publicPath: webpackRCConfig.publicPath || "./".concat(staticDirectory, "/"),
    commons: webpackRCConfig.commons || [{
      async: '__common',
      children: true,
      minChunks: function minChunks(module, count) {
        if (pageCount <= 2) {
          return count >= pageCount;
        }

        return count >= pageCount * 0.5;
      }
    }]
  }, config.disableServiceWorker ? {} : {
    serviceWorker: (0, _extends2.default)({}, webpackRCConfig.serviceWorker || {})
  }))); // Usage:
  // - umi-plugin-yunfengdie

  webpackConfig = (0, _umiPlugin.applyPlugins)(plugins, 'updateWebpackConfig', webpackConfig);
  return webpackConfig;
}