"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = resiterBabelFn;
exports.registerBabelForConfig = registerBabelForConfig;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _toConsumableArray2 = _interopRequireDefault(require("@babel/runtime/helpers/toConsumableArray"));

var _path = require("path");

var _registerBabel = _interopRequireDefault(require("af-webpack/registerBabel"));

var _lodash = _interopRequireDefault(require("lodash.escaperegexp"));

var _constants = require("./constants");

function resiterBabelFn(babelPreset, opts) {
  var only = opts.only,
      disablePreventTest = opts.disablePreventTest,
      ignore = opts.ignore;
  (0, _registerBabel.default)({
    only: only,
    ignore: ignore,
    babelPreset: [babelPreset, {
      disableTransform: true
    }],
    disablePreventTest: disablePreventTest
  });
}

function registerBabelForConfig(babelPreset) {
  var opts = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var paths = opts.paths;
  var files = [].concat((0, _toConsumableArray2.default)(_constants.CONFIG_FILES), ['webpack.config.js', '.webpackrc.js']).map(function (file) {
    return (0, _lodash.default)((0, _path.join)(paths.cwd, file));
  });
  resiterBabelFn(babelPreset, (0, _extends2.default)({}, opts, {
    only: [new RegExp("(".concat(files.join('|'), ")"))]
  }));
}